/*
 * Gimbal
 * Copyright (C) 2024 moonleay
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package net.moonleay.gimbal.constants

import net.moonleay.gimbal.build.BuildConstants

object TranslationKeys {
    object Gui {
        const val BASE = "gui.${BuildConstants.modId}."

        object Config {
            const val BASE = "${TranslationKeys.Gui.BASE}conf."

            const val SCREEN_NAME = "${BASE}settings"
            const val GENERIC_ENABLED = "${BASE}enabled"
            const val GENERIC_DISABLED = "${BASE}disabled"

            const val PLAYER_FLY_SPEED = "${BASE}flySpeed"

            object Hud {
                const val BASE = "${TranslationKeys.Gui.Config.BASE}hud."

                const val SHOW_HUD = "${BASE}show"
                const val EDIT_HUD = "${BASE}edit"
                const val RESET_HUD = "${BASE}reset"
                const val EXAMPLE_HUD_TEXT = "${BASE}example"

                object Modifiers {
                    const val BASE = "${TranslationKeys.Gui.Config.Hud.BASE}modifiers."

                    const val SHOW_MODIFIERS = "${BASE}show"
                    const val SHOW_ALL = "${BASE}all"
                    const val SHOW_NUMBER = "${BASE}number"
                    const val SHOW_INITIALS = "${BASE}initials"
                    const val SHOW_MODE_ONLY = "${BASE}modeOnly"
                }
            }

            object Toasts {
                const val BASE = "${TranslationKeys.Gui.Config.BASE}toasts."

                const val SHOW_TOASTS = "${BASE}show"
                const val SHOW_ALL = "${BASE}all"
                const val SHOW_TOGGLE = "${BASE}toggle"
                const val SHOW_SYSTEM = "${BASE}system"
                const val SHOW_NONE = "${BASE}none"
            }
        }
    }

    object Keybindings {
        // No base here, Categories and Bindings have separate BASEs
        object Category {
            const val BASE = "category.${BuildConstants.modId}."

            object Editor {
                const val BASE = "${TranslationKeys.Keybindings.Category.BASE}editor."

                const val MODE = "${BASE}mode"
                const val MODIFIER = "${BASE}modifier"
            }

            object Game {
                const val BASE = "${TranslationKeys.Keybindings.Category.BASE}game."

                const val GAMEMODE = "${BASE}mode"
            }
        }

        object Binding {
            const val BASE = "key.${BuildConstants.modId}."

            object Editor {
                const val BASE = "${TranslationKeys.Keybindings.Binding.BASE}editor."

                object Mode {
                    const val BASE = "${TranslationKeys.Keybindings.Binding.Editor.BASE}mode."

                    const val INSERT = "${BASE}insert"
                    const val REPLACE = "${BASE}replace"
                    const val VISUAL = "${BASE}visual"
                }

                object Modifier {
                    const val BASE = "${TranslationKeys.Keybindings.Binding.Editor.BASE}modifier."

                    const val BULLDOZER = "${BASE}autoClicker"
                    const val FORCE_PLACE = "${BASE}forcePlace"
                    const val NO_UPDATES = "${BASE}noUpdates"
                    const val NO_CLIP = "${BASE}noClip"
                }
            }

            object Game {
                const val BASE = "${TranslationKeys.Keybindings.Binding.BASE}game."

                object Mode {
                    const val BASE = "${TranslationKeys.Keybindings.Binding.Game.BASE}mode."

                    const val SURVIVAL = "${BASE}survival"
                    const val CREATIVE = "${BASE}creative"
                    const val SPECTATOR = "${BASE}spectator"
                }
            }
        }
    }


}
