/*
 * Gimbal
 * Copyright (C) 2024 moonleay
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package net.moonleay.gimbal.editor.state.mode

enum class ModeModifier(val displayName: String, val shortName: String) {
//    NONE("None"), // No Modifiers - default behavior
NO_UPDATES("NO UPDATES", "NU"), // Do not update blocks when placing
    BULLDOZER("BULLDOZER", "BLR"), // Break blocks fast
    FORCE_PLACE("FORCE", "FP"), // Ignore block placement restrictions
    NO_CLIP("NO CLIP", "NC"), // Do not collide with blocks
}
